



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JavaScript DOM高级程序设计 4.2 事件类型--我要坚持到底！</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JavaScript DOM高级程序设计 4.2 事件类型--我要坚持到底！</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:38:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>对象事件</strong></p>
<ul><li>load和unload（载入页面的时候调用load，关闭页面的时候调用unload）</li>
<li>abort和error</li></ul>
<p>对于载入图像时出现错误的情况，可以使用error事件侦听器来进行说明：</p>
<div>
<pre class="prettyprint linenums">ADS.addEvent(window,'load',function(){<br />
    //创建一个图像元素<br />
    var image=document.createElement('IMG');

    //当图像载入后将其添加到文档主体<br />
    ADS.addEvent(image,'load',function(){<br />
        document.body.appendChild(image);<br />
    });

    //如果载入时出错，则添加相应信息<br />
    ADS.addEvent(image,'error',function(){<br />
        var message=document.createTextNode('The image failed to load');<br />
        document.body.appendChild(message);<br />
    });

    //设置图像的src属性以便浏览器取得图像<br />
    //可以在这边随便添加任何图片的url<br />
    image.setAttribute('src','http://advanceddomscripting.com/images/working.jpg');

    //除了下面的这幅图像不存在而且会发生载入错误外，与上面都相同<br />
    var imageMissing=document.createElement('img');<br />
    ADS.addEvent(imageMissing,'load',function(){<br />
        document.body.appendChild(imageMissing);<br />
    });

    ADS.addEvent(imageMissing,'error',function(){<br />
        var message=document.createTextNode('imageMissing failed to load');<br />
        document.body.appendChild(message);<br />
    });<br />
    //可以在这边随便添加任何图片的url<br />
    imageMissing.setAttribute('src','http://advanceddomscripting.com/images/missing.jpg');<br />
});</pre>
</div>
<ul><li>resize事件（窗口大小调整时该事件被调用）</li>
<li>scroll事件（适用于具有overflow:auto样式的元素，当元素滚动期间被连续调用。）</li></ul>
<p><strong>鼠标移动事件</strong></p>
<ul><li>鼠标移动时候连续调用mousemove</li>
<li>移动到新对象mouseover</li>
<li>移出新对象mouseout</li></ul>
<p><strong><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/449969/201305/27193347-9195363f62544091a8b245a0b06533b5.png" /></strong></p>
<div>
<pre class="prettyprint linenums">ADS.addEvent(window,'load',function(W3CEvent){<br />
    //一个用于将事件类型和对象<br />
    //记录到日志窗口中的方法<br />
    function logit(W3CEvent)<br />
    {<br />
        switch(this.nodetype)<br />
        {<br />
            case ADS.node.DOCUMENT_NODE:<br />
                ADS.log.write(W3CEvent.typp+' on document');<br />
            break;<br />
            case ADS.node.ELEMENT_NODE:<br />
                ADS.log.write(W3CEvent.type+' on box');<br />
            break;<br />
        }<br />
    }

    ADS.addEvent(document,'mousemove',logit);<br />
    ADS.addEvent(document,'mouseover',logit);<br />
    ADS.addEvent(document,'mouseout',logit);

    var box=document.getElementById('box')<br />
    ADS.addEvent(box,'mousemove',logit);<br />
    ADS.addEvent(box,'mouseover',logit);<br />
    ADS.addEvent(box,'mouseout',logit);<br />
});</pre>
</div>
<p><strong>鼠标单击事件</strong></p>
<ul><li>当按下时，mousedown</li>
<li>抬起时mouseup</li>
<li>只有鼠标不动的时候才会发生click</li>
<li>双击dblclick</li></ul>
<div>
<pre class="prettyprint linenums">ADS.addEvent(window,'load',function(W3CEvent){<br />
    //一个用于将事件类型和对象<br />
    //记录到日志窗口中的方法<br />
    function logit(W3CEvent)<br />
    {<br />
        switch(this.nodetype)<br />
        {<br />
            case ADS.node.DOCUMENT_NODE:<br />
                ADS.log.write(W3CEvent.typp+' on document');<br />
            break;<br />
            case ADS.node.ELEMENT_NODE:<br />
                ADS.log.write(W3CEvent.type+' on box');<br />
            break;<br />
        }<br />
    }

    ADS.addEvent(document,'mousedown',logit);<br />
    ADS.addEvent(document,'mouseup',logit);<br />
    ADS.addEvent(document,'dblclick',logit);

    var box=document.getElementById('box')<br />
    ADS.addEvent(box,'mousedown',logit);<br />
    ADS.addEvent(box,'mouseup',logit);<br />
    ADS.addEvent(box,'click',logit);<br />
    ADS.addEvent(box,'dblclick',logit);<br />
});</pre>
</div>
<p><strong>键盘事件</strong></p>
<ul><li>keydown某个键盘被按下时调用。</li>
<li>keyup事件相应的键被释放时调用。</li>
<li>keypress事件紧随keyup事件之后。</li></ul>
<p><strong>表单相关事件</strong></p>
<ul><li>submit和reset事件</li></ul>
<p>这里有个js代码，验证加拿大邮政编码的，很简单，所以仅仅看看代码。</p>
<div>
<pre class="prettyprint linenums">function isPostalCode(s)<br />
{<br />
    return s.toUpperCase().match(/[A-Z][0-9]\s*[0-9][A-Z][0-9]/i);<br />
}<br />
ADS.addEvent(window,'load',function(){<br />
    ADS.addEvent(<br />
        document.getElementById('canadianAddress'),<br />
        'submit',<br />
        function(W3CEvent){<br />
            var postalCode=document.getElementById('postalCode').value;<br />
            //使用正则表达式来检查格式是否有效<br />
            if (!isPostalCode(posalCode))<br />
            {<br />
                alert('That\'s not a valid Canadian postal code!');

                //提交表单<br />
                ADS.preventDefault(W3CEvent);<br />
            }<br />
        }<br />
    );<br />
});</pre>
</div>
<ul><li>blur和focus事件</li></ul>
<p>focus事件会在用户单机一个元素或者通过按Tab键遣换到一个元素时候被调用，而单机元素之外其他地方护着Tab键离开元素，则会在原先调用focus事件元素上调用blur事件</p>
<p>下面是为了邮政编码字段添加blur和focus侦听器的载入事件侦听器</p>
<div>
<pre class="prettyprint linenums">ADS.addEvent(window,'load',function(){<br />
    //添加初始样式<br />
    var postalCode=document.getElementById('postalCode');<br />
    postalCode.className='inputMissing';

    //当获取焦点屎将类修改为编辑<br />
    ADS.addEvent(postalCode,'focus',function(W3CEvent){<br />
        //通过修改类来表示用户正在编辑这个字段<br />
        this.className='inputEditing';<br />
    });<br />
    //当失去焦点时候对信息进行验证，并根据输入的值是否有效重新修改样式<br />
    ADS.addEvent(postalCode,'blur',function(W3CEvent))<br />
    {<br />
        if (this.value=='')<br />
        {<br />
            //修改类以表示缺少内容<br />
            this.className='inputMissing';

        }else if (!isPostalCode(this.value))<br />
        {<br />
            //修改类以表示内容无效<br />
            this.className='inputInvalid';<br />
        }else<br />
        {<br />
            //修改样式以表示内容完成<br />
            this.className='inputComplete';<br />
        }<br />
    }

});</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/449969/201305/27214347-f1db03b2ed0c4c8f97cbae1a5c990a89.png" /></p>
<ul><li>change事件</li></ul>
<p>适用于&lt;input&gt;,&lt;select&gt;,&lt;textarea&gt;表单元素，该事件会在focus事件发生后，当用户在focus和blur之间进行修改元素的值时被调用。</p>
<div>
<pre class="prettyprint linenums">//验证表单的同时，还能自动生成表单其他字段的内容<br />
ADS.addEvent(window,'load',function(){<br />
    var postalCode=ADS.$('postalCode');

    ADS.addEvent(postalCode,'change',function(W3CEvent){<br />
        var newPostalCode=this.value<br />
        if (!isPostalCode(newPostalCode))<br />
        {<br />
            return;<br />
        }<br />
        var reg=new XMLhttpRequest();<br />
        req.open('POST','server.js?postalCode='+newPostalCode,true);<br />
        req.onreadystatechange=function(){<br />
            if (req.readyState==4)<br />
            {<br />
                eval(req.responsetText);<br />
                if (ADS.$('street').value=='')<br />
                {<br />
                    ADS.$('street').value=street;<br />
                }<br />
                if (ADS.$('city').value=='')<br />
                {<br />
                    ADS.$('city').value=city;<br />
                }<br />
                if (ADS.$('province').value=='')<br />
                {<br />
                    ADS.$('province').value=province;<br />
                }<br />
            }<br />
        }<br />
        req.send();<br />
    });<br />
});</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7l1ne8.html">UILabel内容模糊</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j26jg8.html">Qt实用小技巧（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ewrge8.html">javascript 零星知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk3x58.html">python学习 文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952ple9.html">asp&period;net&period;mvc4在vs2010怎样创建mvc项目及它的结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/39reyzdq.html">C语言 野指针与空指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd32d78.html">leetcode面试准备&colon;Container With Most Water</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0o264q.html">java NIO的多路复用及reactor模式【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/96or4mj9.html">无锁，线程安全，延迟加载的单例实现（C&num;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwpxn8.html">BZOJ 1146&colon; &lbrack;CTSC2008&rsqb;网络管理Network&lpar; 树链剖分 &plus; 树状数组套主席树 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950por68.html">HTTP代理浅说</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2xg59.html">Java开发工具&lpar;Eclipse中内容辅助键的使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkm479.html">微信网页授权封装接口&mdash;&mdash;node&period;js版</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz465g8.html">codeforces&mdash;&mdash;961C&period; Chessboard</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxden6d9.html">ubuntu14&period;04上引入thinkphp5类库遇到的一个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1yrd1q.html">记录Ok6410 sd 启动uboot</a>
		</li>
						<li><a href="https://www.batexi.com/a/960zp3j9.html">CentOS内网机器利用iptables共享公网IP上网</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wln0nq.html">python番外篇--sql注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykrzgq.html">embedding与word2vec</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm6ej09.html">人脸识别技术大总结1&mdash;&mdash;Face Detection &amp;amp&semi; Alignment</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1zynv29.html">link方式安装Eclispe插件：greenUML</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmz6ee9.html">非常出色的一款WinForm窗体重绘GUI类库源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmwdne9.html">弹性布局学习-详解align-content&lpar;六&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z16n639.html">Oracle RAC LoadBalance</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvjmxoq.html">50个C&plus;&plus;源码学习网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd62xe8.html">fedora gnome extension</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn6vke8.html">Google code&colon; Why &OpenCurlyQuote;Everything up-to-date&rsquo; when pushing &lpar;git&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zy3v49.html">Oracle的Export用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj7rm79.html">《ENVI下遥感影像自然真彩色合成方法》&mdash;&mdash;TM、spot5</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeg2dv9.html">SQLite3中自增主键</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
